#include <iostream>
#include <string>
#include <vector>

class Person {
	std::string m_name;
	unsigned m_salary = 0;

public:
	Person(const std::string& name)
	    : m_name(name) {}
	const std::string& name() const { return m_name; }
	void tell() const { std::cout << m_name << ": " << m_salary << "\n"; }

	friend void renamePerson(Person& p, const std::string& name);
	friend class Employer;
};

void renamePerson(Person& p, const std::string& name) {
	p.m_name = name;
}

class Employer {
	std::vector<Person*> employees;

public:
	void addEmployee(Person& person) {
		employees.push_back(&person);
	}
	void raiseAll() {
		for (Person* employee : employees) {
			employee->m_salary += 1;
		}
	}
};

int main() {
	Person edric("Edric");
	renamePerson(edric, "Edric The Navigator");
	Employer guild;
	guild.addEmployee(edric);
	guild.raiseAll();
	edric.tell();
}
