#include <iostream>

class Vector3D {
	double x, y, z;

public:
	Vector3D(double x, double y, double z)
	    : x(x)
	    , y(y)
	    , z(z) {}

	void tell() const {
		std::cout << "(" << x << ", " << y << ", " << z << ")\n";
	}

	friend Vector3D operator+(const Vector3D& first, const Vector3D& second);
};

inline Vector3D operator+(const Vector3D& first, const Vector3D& second) {
	return { first.x + second.x, first.y + second.y, first.z + second.z };
}

int main() {
	Vector3D u(1, 2, 3);
	Vector3D v(0, 0, 7);
	(u + v).tell();
}
