#include <iostream>
#include <set>
#include <string>

class Person {
	std::string name, surname;

public:
	Person(const std::string& name, const std::string& surname)
	    : name(name)
	    , surname(surname) {}
	void tell() const { std::cout << name << ' ' << surname << '\n'; }

	friend bool operator<(const Person& lhs, const Person& rhs) {
		if (lhs.surname < rhs.surname)
			return true;
		if (rhs.surname < lhs.surname)
			return false;
		return lhs.name < rhs.name;
	}

	friend bool operator>(const Person& lhs, const Person& rhs) {
		return rhs < lhs;
	}

	friend bool operator<=(const Person& lhs, const Person& rhs) {
		return !(rhs < lhs);
	}

	friend bool operator>=(const Person& lhs, const Person& rhs) {
		return !(lhs < rhs);
	}

	friend bool operator==(const Person& lhs, const Person& rhs) {
		return lhs.name == rhs.name && lhs.surname == rhs.surname;
	}

	friend bool operator!=(const Person& lhs, const Person& rhs) {
		return !(rhs == lhs);
	}
};

int main() {
	std::set<Person> people = {
		{ "Paul", "Atreides" },
		{ "Vladimir", "Harkonnen" },
		{ "Duncan", "Idaho" },
		{ "Leto", "Atreides" },
	};

	for (const Person& person : people) {
		person.tell();
	}
}
