#include <iostream>

class Vector3D {
	double x, y, z;

public:
	Vector3D(double x, double y, double z)
	    : x(x)
	    , y(y)
	    , z(z) {}

	void tell() const {
		std::cout << "(" << x << ", " << y << ", " << z << ")\n";
	}

	Vector3D& operator+=(const Vector3D& second) {
		x += second.x;
		y += second.y;
		z += second.z;
		return *this;
	}

	Vector3D& operator*=(double coeff) {
		x *= coeff;
		y *= coeff;
		z *= coeff;
		return *this;
	}

	friend Vector3D operator+(Vector3D lhs, const Vector3D& rhs) {
		lhs += rhs;
		return lhs;
		// note -- don't do this, it makes another copy:
		//   return lhs += rhs;
	}

	friend Vector3D operator*(Vector3D lhs, double coeff) {
		lhs *= coeff;
		return lhs;
	}

	friend Vector3D operator*(double coeff, Vector3D rhs) {
		rhs *= coeff;
		return rhs;
	}
};

int main() {
	Vector3D u(1, 2, 3);
	Vector3D v(0, 0, 7);
	Vector3D w(2, 3, 5);
	(3.14 * (u + v + w)).tell();
}
