#include <iostream>
#include <memory>

class IntArray {
	size_t size;
	std::unique_ptr<int[]> array;

public:
	IntArray(size_t s)
	    : size(s)
	    , array(std::make_unique<int[]>(size)) {}

	int& operator[](size_t index) { return array[index]; }

	// the return type of the following overloaded operator []
	// could possibly be just int; returning const int& here
	// has the advantage that the caller may use &arr[0] to get
	// a pointer to the underlying array
	const int& operator[](size_t index) const { return array[index]; }
};

int main() {
	IntArray arr(10);
	for (int i = 0; i < 10; ++i) {
		arr[i] = i;
	}
	const IntArray& ref = arr;
	for (int i = 0; i < 10; ++i) {
		std::cout << ref[i] << '\n';
	}
}
