#include <iostream>
#include <string>

class Person {
	std::string name;
	int salary = 0;

public:
	Person(const std::string& name)
	    : name(name) {}
	void raiseSalaryBy(int amount) { salary += amount; }
	friend std::ostream& operator<<(std::ostream& out, const Person& person);
};

inline std::ostream& operator<<(std::ostream& out, const Person& person) {
	return out << person.name << " (salary: " << person.salary << " USD)";
}

int main() {
	Person homer("Homer Simpson");
	std::cout << homer << " is sad!\n";
	homer.raiseSalaryBy(1000);
	std::cout << homer << " is happy!\n";
}
